﻿using Infragistics.Windows;
using Infragistics.Windows.DockManager;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamDockManagerFocusCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void XamDockManager_ToolWindowLoaded(object sender, Infragistics.Windows.DockManager.Events.PaneToolWindowEventArgs e)
        {
            //THIS WINDOW IS HOSTED BY ToolWindowHostWindow. THAT ELEMENT HAS ISFOCUSSCOPE = TRUE.
            PaneToolWindow PTW = e.Window as PaneToolWindow;

            bool x = FocusManager.GetIsFocusScope(PTW);

             //ContentPane pane = e.Window.FindChildByType();

            ContentPane pane = new ContentPane();

            foreach (var p in DM1.GetPanes(PaneNavigationOrder.VisibleOrder))
            {
                pane = p as ContentPane;

            }

            if (pane != null)
            {

                // Re-route all events to the owning window of this tool window.

                RoutedEvent[] routedEvents = EventManager.GetRoutedEvents();

                foreach (RoutedEvent routedEvent in routedEvents)
                {

                    e.Window.AddHandler(routedEvent, new RoutedEventHandler(RoutedEventDispatcher));

                }


                // You cannot tab from microsoft controls if there is no focus scope on the pane when floated. So this is a workaround.

                FocusManager.SetIsFocusScope(pane, true);


                e.Window.Closed += (EventHandler)delegate
                {

                    // Turn off the focus scope so it is part of the main window.

                    FocusManager.SetIsFocusScope(pane, false);

                };
            }
        }

        private void RoutedEventDispatcher(object sender, RoutedEventArgs e)
        {
            //if (((FrameworkElement)Parent) != null)
            //{
            //    ((FrameworkElement)Parent).RaiseEvent(e);
            //}
        }
    }
}
